// Code generated by SQLBoiler (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package postgres

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/pkg/errors"
	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/queries/qm"
	"github.com/volatiletech/sqlboiler/queries/qmhelper"
	"github.com/volatiletech/sqlboiler/strmangle"
	"github.com/volatiletech/sqlboiler/types"
)

// Driver is an object representing the database table.
type Driver struct {
	ID      int64             `boil:"id" json:"id" toml:"id" yaml:"id"`
	Phone   string            `boil:"phone" json:"phone" toml:"phone" yaml:"phone"`
	Profile types.JSON        `boil:"profile" json:"profile" toml:"profile" yaml:"profile"`
	Rating  types.Decimal     `boil:"rating" json:"rating" toml:"rating" yaml:"rating"`
	Lon     types.NullDecimal `boil:"lon" json:"lon,omitempty" toml:"lon" yaml:"lon,omitempty"`
	Lat     types.NullDecimal `boil:"lat" json:"lat,omitempty" toml:"lat" yaml:"lat,omitempty"`

	R *driverR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L driverL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var DriverColumns = struct {
	ID      string
	Phone   string
	Profile string
	Rating  string
	Lon     string
	Lat     string
}{
	ID:      "id",
	Phone:   "phone",
	Profile: "profile",
	Rating:  "rating",
	Lon:     "lon",
	Lat:     "lat",
}

// Generated where

type whereHelperint64 struct{ field string }

func (w whereHelperint64) EQ(x int64) qm.QueryMod  { return qmhelper.Where(w.field, qmhelper.EQ, x) }
func (w whereHelperint64) NEQ(x int64) qm.QueryMod { return qmhelper.Where(w.field, qmhelper.NEQ, x) }
func (w whereHelperint64) LT(x int64) qm.QueryMod  { return qmhelper.Where(w.field, qmhelper.LT, x) }
func (w whereHelperint64) LTE(x int64) qm.QueryMod { return qmhelper.Where(w.field, qmhelper.LTE, x) }
func (w whereHelperint64) GT(x int64) qm.QueryMod  { return qmhelper.Where(w.field, qmhelper.GT, x) }
func (w whereHelperint64) GTE(x int64) qm.QueryMod { return qmhelper.Where(w.field, qmhelper.GTE, x) }

type whereHelpertypes_JSON struct{ field string }

func (w whereHelpertypes_JSON) EQ(x types.JSON) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.EQ, x)
}
func (w whereHelpertypes_JSON) NEQ(x types.JSON) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.NEQ, x)
}
func (w whereHelpertypes_JSON) LT(x types.JSON) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LT, x)
}
func (w whereHelpertypes_JSON) LTE(x types.JSON) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LTE, x)
}
func (w whereHelpertypes_JSON) GT(x types.JSON) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GT, x)
}
func (w whereHelpertypes_JSON) GTE(x types.JSON) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GTE, x)
}

type whereHelpertypes_Decimal struct{ field string }

func (w whereHelpertypes_Decimal) EQ(x types.Decimal) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.EQ, x)
}
func (w whereHelpertypes_Decimal) NEQ(x types.Decimal) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.NEQ, x)
}
func (w whereHelpertypes_Decimal) LT(x types.Decimal) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LT, x)
}
func (w whereHelpertypes_Decimal) LTE(x types.Decimal) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LTE, x)
}
func (w whereHelpertypes_Decimal) GT(x types.Decimal) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GT, x)
}
func (w whereHelpertypes_Decimal) GTE(x types.Decimal) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GTE, x)
}

type whereHelpertypes_NullDecimal struct{ field string }

func (w whereHelpertypes_NullDecimal) EQ(x types.NullDecimal) qm.QueryMod {
	return qmhelper.WhereNullEQ(w.field, false, x)
}
func (w whereHelpertypes_NullDecimal) NEQ(x types.NullDecimal) qm.QueryMod {
	return qmhelper.WhereNullEQ(w.field, true, x)
}
func (w whereHelpertypes_NullDecimal) IsNull() qm.QueryMod    { return qmhelper.WhereIsNull(w.field) }
func (w whereHelpertypes_NullDecimal) IsNotNull() qm.QueryMod { return qmhelper.WhereIsNotNull(w.field) }
func (w whereHelpertypes_NullDecimal) LT(x types.NullDecimal) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LT, x)
}
func (w whereHelpertypes_NullDecimal) LTE(x types.NullDecimal) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LTE, x)
}
func (w whereHelpertypes_NullDecimal) GT(x types.NullDecimal) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GT, x)
}
func (w whereHelpertypes_NullDecimal) GTE(x types.NullDecimal) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GTE, x)
}

var DriverWhere = struct {
	ID      whereHelperint64
	Phone   whereHelperstring
	Profile whereHelpertypes_JSON
	Rating  whereHelpertypes_Decimal
	Lon     whereHelpertypes_NullDecimal
	Lat     whereHelpertypes_NullDecimal
}{
	ID:      whereHelperint64{field: "\"driver\".\"id\""},
	Phone:   whereHelperstring{field: "\"driver\".\"phone\""},
	Profile: whereHelpertypes_JSON{field: "\"driver\".\"profile\""},
	Rating:  whereHelpertypes_Decimal{field: "\"driver\".\"rating\""},
	Lon:     whereHelpertypes_NullDecimal{field: "\"driver\".\"lon\""},
	Lat:     whereHelpertypes_NullDecimal{field: "\"driver\".\"lat\""},
}

// DriverRels is where relationship names are stored.
var DriverRels = struct {
	DriverTokens string
	Offers       string
	OrderDeals   string
	Transports   string
}{
	DriverTokens: "DriverTokens",
	Offers:       "Offers",
	OrderDeals:   "OrderDeals",
	Transports:   "Transports",
}

// driverR is where relationships are stored.
type driverR struct {
	DriverTokens DriverTokenSlice
	Offers       OfferSlice
	OrderDeals   OrderDealSlice
	Transports   TransportSlice
}

// NewStruct creates a new relationship struct
func (*driverR) NewStruct() *driverR {
	return &driverR{}
}

// driverL is where Load methods for each relationship are stored.
type driverL struct{}

var (
	driverColumns               = []string{"id", "phone", "profile", "rating", "lon", "lat"}
	driverColumnsWithoutDefault = []string{"phone", "profile", "lon", "lat"}
	driverColumnsWithDefault    = []string{"id", "rating"}
	driverPrimaryKeyColumns     = []string{"id"}
)

type (
	// DriverSlice is an alias for a slice of pointers to Driver.
	// This should generally be used opposed to []Driver.
	DriverSlice []*Driver
	// DriverHook is the signature for custom Driver hook methods
	DriverHook func(context.Context, boil.ContextExecutor, *Driver) error

	driverQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	driverType                 = reflect.TypeOf(&Driver{})
	driverMapping              = queries.MakeStructMapping(driverType)
	driverPrimaryKeyMapping, _ = queries.BindMapping(driverType, driverMapping, driverPrimaryKeyColumns)
	driverInsertCacheMut       sync.RWMutex
	driverInsertCache          = make(map[string]insertCache)
	driverUpdateCacheMut       sync.RWMutex
	driverUpdateCache          = make(map[string]updateCache)
	driverUpsertCacheMut       sync.RWMutex
	driverUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var driverBeforeInsertHooks []DriverHook
var driverBeforeUpdateHooks []DriverHook
var driverBeforeDeleteHooks []DriverHook
var driverBeforeUpsertHooks []DriverHook

var driverAfterInsertHooks []DriverHook
var driverAfterSelectHooks []DriverHook
var driverAfterUpdateHooks []DriverHook
var driverAfterDeleteHooks []DriverHook
var driverAfterUpsertHooks []DriverHook

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *Driver) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *Driver) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *Driver) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *Driver) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *Driver) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterSelectHooks executes all "after Select" hooks.
func (o *Driver) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *Driver) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *Driver) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *Driver) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range driverAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddDriverHook registers your hook function for all future operations.
func AddDriverHook(hookPoint boil.HookPoint, driverHook DriverHook) {
	switch hookPoint {
	case boil.BeforeInsertHook:
		driverBeforeInsertHooks = append(driverBeforeInsertHooks, driverHook)
	case boil.BeforeUpdateHook:
		driverBeforeUpdateHooks = append(driverBeforeUpdateHooks, driverHook)
	case boil.BeforeDeleteHook:
		driverBeforeDeleteHooks = append(driverBeforeDeleteHooks, driverHook)
	case boil.BeforeUpsertHook:
		driverBeforeUpsertHooks = append(driverBeforeUpsertHooks, driverHook)
	case boil.AfterInsertHook:
		driverAfterInsertHooks = append(driverAfterInsertHooks, driverHook)
	case boil.AfterSelectHook:
		driverAfterSelectHooks = append(driverAfterSelectHooks, driverHook)
	case boil.AfterUpdateHook:
		driverAfterUpdateHooks = append(driverAfterUpdateHooks, driverHook)
	case boil.AfterDeleteHook:
		driverAfterDeleteHooks = append(driverAfterDeleteHooks, driverHook)
	case boil.AfterUpsertHook:
		driverAfterUpsertHooks = append(driverAfterUpsertHooks, driverHook)
	}
}

// One returns a single driver record from the query.
func (q driverQuery) One(ctx context.Context, exec boil.ContextExecutor) (*Driver, error) {
	o := &Driver{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Cause(err) == sql.ErrNoRows {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "postgres: failed to execute a one query for driver")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all Driver records from the query.
func (q driverQuery) All(ctx context.Context, exec boil.ContextExecutor) (DriverSlice, error) {
	var o []*Driver

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "postgres: failed to assign all query results to Driver slice")
	}

	if len(driverAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all Driver records in the query.
func (q driverQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to count driver rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q driverQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "postgres: failed to check if driver exists")
	}

	return count > 0, nil
}

// DriverTokens retrieves all the driver_token's DriverTokens with an executor.
func (o *Driver) DriverTokens(mods ...qm.QueryMod) driverTokenQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"driver_token\".\"driver_id\"=?", o.ID),
	)

	query := DriverTokens(queryMods...)
	queries.SetFrom(query.Query, "\"driver_token\"")

	if len(queries.GetSelect(query.Query)) == 0 {
		queries.SetSelect(query.Query, []string{"\"driver_token\".*"})
	}

	return query
}

// Offers retrieves all the offer's Offers with an executor.
func (o *Driver) Offers(mods ...qm.QueryMod) offerQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"offer\".\"driver_id\"=?", o.ID),
	)

	query := Offers(queryMods...)
	queries.SetFrom(query.Query, "\"offer\"")

	if len(queries.GetSelect(query.Query)) == 0 {
		queries.SetSelect(query.Query, []string{"\"offer\".*"})
	}

	return query
}

// OrderDeals retrieves all the order_deal's OrderDeals with an executor.
func (o *Driver) OrderDeals(mods ...qm.QueryMod) orderDealQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"order_deal\".\"driver_id\"=?", o.ID),
	)

	query := OrderDeals(queryMods...)
	queries.SetFrom(query.Query, "\"order_deal\"")

	if len(queries.GetSelect(query.Query)) == 0 {
		queries.SetSelect(query.Query, []string{"\"order_deal\".*"})
	}

	return query
}

// Transports retrieves all the transport's Transports with an executor.
func (o *Driver) Transports(mods ...qm.QueryMod) transportQuery {
	var queryMods []qm.QueryMod
	if len(mods) != 0 {
		queryMods = append(queryMods, mods...)
	}

	queryMods = append(queryMods,
		qm.Where("\"transport\".\"driver_id\"=?", o.ID),
	)

	query := Transports(queryMods...)
	queries.SetFrom(query.Query, "\"transport\"")

	if len(queries.GetSelect(query.Query)) == 0 {
		queries.SetSelect(query.Query, []string{"\"transport\".*"})
	}

	return query
}

// LoadDriverTokens allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (driverL) LoadDriverTokens(ctx context.Context, e boil.ContextExecutor, singular bool, maybeDriver interface{}, mods queries.Applicator) error {
	var slice []*Driver
	var object *Driver

	if singular {
		object = maybeDriver.(*Driver)
	} else {
		slice = *maybeDriver.(*[]*Driver)
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &driverR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &driverR{}
			}

			for _, a := range args {
				if a == obj.ID {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(qm.From(`driver_token`), qm.WhereIn(`driver_id in ?`, args...))
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load driver_token")
	}

	var resultSlice []*DriverToken
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice driver_token")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on driver_token")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for driver_token")
	}

	if len(driverTokenAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.DriverTokens = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &driverTokenR{}
			}
			foreign.R.Driver = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if local.ID == foreign.DriverID {
				local.R.DriverTokens = append(local.R.DriverTokens, foreign)
				if foreign.R == nil {
					foreign.R = &driverTokenR{}
				}
				foreign.R.Driver = local
				break
			}
		}
	}

	return nil
}

// LoadOffers allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (driverL) LoadOffers(ctx context.Context, e boil.ContextExecutor, singular bool, maybeDriver interface{}, mods queries.Applicator) error {
	var slice []*Driver
	var object *Driver

	if singular {
		object = maybeDriver.(*Driver)
	} else {
		slice = *maybeDriver.(*[]*Driver)
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &driverR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &driverR{}
			}

			for _, a := range args {
				if a == obj.ID {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(qm.From(`offer`), qm.WhereIn(`driver_id in ?`, args...))
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load offer")
	}

	var resultSlice []*Offer
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice offer")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on offer")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for offer")
	}

	if len(offerAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.Offers = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &offerR{}
			}
			foreign.R.Driver = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if local.ID == foreign.DriverID {
				local.R.Offers = append(local.R.Offers, foreign)
				if foreign.R == nil {
					foreign.R = &offerR{}
				}
				foreign.R.Driver = local
				break
			}
		}
	}

	return nil
}

// LoadOrderDeals allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (driverL) LoadOrderDeals(ctx context.Context, e boil.ContextExecutor, singular bool, maybeDriver interface{}, mods queries.Applicator) error {
	var slice []*Driver
	var object *Driver

	if singular {
		object = maybeDriver.(*Driver)
	} else {
		slice = *maybeDriver.(*[]*Driver)
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &driverR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &driverR{}
			}

			for _, a := range args {
				if a == obj.ID {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(qm.From(`order_deal`), qm.WhereIn(`driver_id in ?`, args...))
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load order_deal")
	}

	var resultSlice []*OrderDeal
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice order_deal")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on order_deal")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for order_deal")
	}

	if len(orderDealAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.OrderDeals = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &orderDealR{}
			}
			foreign.R.Driver = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if local.ID == foreign.DriverID {
				local.R.OrderDeals = append(local.R.OrderDeals, foreign)
				if foreign.R == nil {
					foreign.R = &orderDealR{}
				}
				foreign.R.Driver = local
				break
			}
		}
	}

	return nil
}

// LoadTransports allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for a 1-M or N-M relationship.
func (driverL) LoadTransports(ctx context.Context, e boil.ContextExecutor, singular bool, maybeDriver interface{}, mods queries.Applicator) error {
	var slice []*Driver
	var object *Driver

	if singular {
		object = maybeDriver.(*Driver)
	} else {
		slice = *maybeDriver.(*[]*Driver)
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &driverR{}
		}
		args = append(args, object.ID)
	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &driverR{}
			}

			for _, a := range args {
				if a == obj.ID {
					continue Outer
				}
			}

			args = append(args, obj.ID)
		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(qm.From(`transport`), qm.WhereIn(`driver_id in ?`, args...))
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load transport")
	}

	var resultSlice []*Transport
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice transport")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results in eager load on transport")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for transport")
	}

	if len(transportAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}
	if singular {
		object.R.Transports = resultSlice
		for _, foreign := range resultSlice {
			if foreign.R == nil {
				foreign.R = &transportR{}
			}
			foreign.R.Driver = object
		}
		return nil
	}

	for _, foreign := range resultSlice {
		for _, local := range slice {
			if local.ID == foreign.DriverID {
				local.R.Transports = append(local.R.Transports, foreign)
				if foreign.R == nil {
					foreign.R = &transportR{}
				}
				foreign.R.Driver = local
				break
			}
		}
	}

	return nil
}

// AddDriverTokens adds the given related objects to the existing relationships
// of the driver, optionally inserting them as new records.
// Appends related to o.R.DriverTokens.
// Sets related.R.Driver appropriately.
func (o *Driver) AddDriverTokens(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*DriverToken) error {
	var err error
	for _, rel := range related {
		if insert {
			rel.DriverID = o.ID
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"driver_token\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"driver_id"}),
				strmangle.WhereClause("\"", "\"", 2, driverTokenPrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.ID}

			if boil.DebugMode {
				fmt.Fprintln(boil.DebugWriter, updateQuery)
				fmt.Fprintln(boil.DebugWriter, values)
			}

			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			rel.DriverID = o.ID
		}
	}

	if o.R == nil {
		o.R = &driverR{
			DriverTokens: related,
		}
	} else {
		o.R.DriverTokens = append(o.R.DriverTokens, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &driverTokenR{
				Driver: o,
			}
		} else {
			rel.R.Driver = o
		}
	}
	return nil
}

// AddOffers adds the given related objects to the existing relationships
// of the driver, optionally inserting them as new records.
// Appends related to o.R.Offers.
// Sets related.R.Driver appropriately.
func (o *Driver) AddOffers(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*Offer) error {
	var err error
	for _, rel := range related {
		if insert {
			rel.DriverID = o.ID
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"offer\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"driver_id"}),
				strmangle.WhereClause("\"", "\"", 2, offerPrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.ID}

			if boil.DebugMode {
				fmt.Fprintln(boil.DebugWriter, updateQuery)
				fmt.Fprintln(boil.DebugWriter, values)
			}

			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			rel.DriverID = o.ID
		}
	}

	if o.R == nil {
		o.R = &driverR{
			Offers: related,
		}
	} else {
		o.R.Offers = append(o.R.Offers, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &offerR{
				Driver: o,
			}
		} else {
			rel.R.Driver = o
		}
	}
	return nil
}

// AddOrderDeals adds the given related objects to the existing relationships
// of the driver, optionally inserting them as new records.
// Appends related to o.R.OrderDeals.
// Sets related.R.Driver appropriately.
func (o *Driver) AddOrderDeals(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*OrderDeal) error {
	var err error
	for _, rel := range related {
		if insert {
			rel.DriverID = o.ID
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"order_deal\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"driver_id"}),
				strmangle.WhereClause("\"", "\"", 2, orderDealPrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.ID}

			if boil.DebugMode {
				fmt.Fprintln(boil.DebugWriter, updateQuery)
				fmt.Fprintln(boil.DebugWriter, values)
			}

			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			rel.DriverID = o.ID
		}
	}

	if o.R == nil {
		o.R = &driverR{
			OrderDeals: related,
		}
	} else {
		o.R.OrderDeals = append(o.R.OrderDeals, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &orderDealR{
				Driver: o,
			}
		} else {
			rel.R.Driver = o
		}
	}
	return nil
}

// AddTransports adds the given related objects to the existing relationships
// of the driver, optionally inserting them as new records.
// Appends related to o.R.Transports.
// Sets related.R.Driver appropriately.
func (o *Driver) AddTransports(ctx context.Context, exec boil.ContextExecutor, insert bool, related ...*Transport) error {
	var err error
	for _, rel := range related {
		if insert {
			rel.DriverID = o.ID
			if err = rel.Insert(ctx, exec, boil.Infer()); err != nil {
				return errors.Wrap(err, "failed to insert into foreign table")
			}
		} else {
			updateQuery := fmt.Sprintf(
				"UPDATE \"transport\" SET %s WHERE %s",
				strmangle.SetParamNames("\"", "\"", 1, []string{"driver_id"}),
				strmangle.WhereClause("\"", "\"", 2, transportPrimaryKeyColumns),
			)
			values := []interface{}{o.ID, rel.ID}

			if boil.DebugMode {
				fmt.Fprintln(boil.DebugWriter, updateQuery)
				fmt.Fprintln(boil.DebugWriter, values)
			}

			if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
				return errors.Wrap(err, "failed to update foreign table")
			}

			rel.DriverID = o.ID
		}
	}

	if o.R == nil {
		o.R = &driverR{
			Transports: related,
		}
	} else {
		o.R.Transports = append(o.R.Transports, related...)
	}

	for _, rel := range related {
		if rel.R == nil {
			rel.R = &transportR{
				Driver: o,
			}
		} else {
			rel.R.Driver = o
		}
	}
	return nil
}

// Drivers retrieves all the records using an executor.
func Drivers(mods ...qm.QueryMod) driverQuery {
	mods = append(mods, qm.From("\"driver\""))
	return driverQuery{NewQuery(mods...)}
}

// FindDriver retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindDriver(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*Driver, error) {
	driverObj := &Driver{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"driver\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, driverObj)
	if err != nil {
		if errors.Cause(err) == sql.ErrNoRows {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "postgres: unable to select from driver")
	}

	return driverObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *Driver) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("postgres: no driver provided for insertion")
	}

	var err error

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(driverColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	driverInsertCacheMut.RLock()
	cache, cached := driverInsertCache[key]
	driverInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			driverColumns,
			driverColumnsWithDefault,
			driverColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(driverType, driverMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(driverType, driverMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"driver\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"driver\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "postgres: unable to insert into driver")
	}

	if !cached {
		driverInsertCacheMut.Lock()
		driverInsertCache[key] = cache
		driverInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the Driver.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *Driver) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	driverUpdateCacheMut.RLock()
	cache, cached := driverUpdateCache[key]
	driverUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			driverColumns,
			driverPrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("postgres: unable to update driver, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"driver\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, driverPrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(driverType, driverMapping, append(wl, driverPrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, values)
	}

	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update driver row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by update for driver")
	}

	if !cached {
		driverUpdateCacheMut.Lock()
		driverUpdateCache[key] = cache
		driverUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q driverQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update all for driver")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to retrieve rows affected for driver")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o DriverSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("postgres: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), driverPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"driver\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, driverPrimaryKeyColumns, len(o)))

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args...)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to update all in driver slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to retrieve rows affected all in update all driver")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *Driver) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("postgres: no driver provided for upsert")
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(driverColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	driverUpsertCacheMut.RLock()
	cache, cached := driverUpsertCache[key]
	driverUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			driverColumns,
			driverColumnsWithDefault,
			driverColumnsWithoutDefault,
			nzDefaults,
		)
		update := updateColumns.UpdateColumnSet(
			driverColumns,
			driverPrimaryKeyColumns,
		)

		if len(update) == 0 {
			return errors.New("postgres: unable to upsert driver, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(driverPrimaryKeyColumns))
			copy(conflict, driverPrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"driver\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(driverType, driverMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(driverType, driverMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, cache.query)
		fmt.Fprintln(boil.DebugWriter, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if err == sql.ErrNoRows {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "postgres: unable to upsert driver")
	}

	if !cached {
		driverUpsertCacheMut.Lock()
		driverUpsertCache[key] = cache
		driverUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single Driver record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *Driver) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("postgres: no Driver provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), driverPrimaryKeyMapping)
	sql := "DELETE FROM \"driver\" WHERE \"id\"=$1"

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args...)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete from driver")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by delete for driver")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q driverQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("postgres: no driverQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete all from driver")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by deleteall for driver")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o DriverSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(driverBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), driverPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"driver\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, driverPrimaryKeyColumns, len(o))

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, args)
	}

	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "postgres: unable to delete all from driver slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "postgres: failed to get rows affected by deleteall for driver")
	}

	if len(driverAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *Driver) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindDriver(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *DriverSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := DriverSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), driverPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"driver\".* FROM \"driver\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, driverPrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "postgres: unable to reload all in DriverSlice")
	}

	*o = slice

	return nil
}

// DriverExists checks if the Driver row exists.
func DriverExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"driver\" where \"id\"=$1 limit 1)"

	if boil.DebugMode {
		fmt.Fprintln(boil.DebugWriter, sql)
		fmt.Fprintln(boil.DebugWriter, iD)
	}

	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "postgres: unable to check if driver exists")
	}

	return exists, nil
}
